<?php

use Drp\NativeEventApp\Migrations\TableMigration;
use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;

class CreateFileUploadsTable extends TableMigration
{
    public function up(): void
    {
        Schema::create($this->getTableNameWithPrefix(), static function (Blueprint $table): void {
            $table->bigIncrements('id');
            $table->uuid('uuid')->unique();
            $table->string('type')->nullable();
            $table->string('disk')->nullable();
            $table->string('path')->nullable();
            $table->unsignedBigInteger('registration_id');
            $table->timestamps();
        });
    }

    public function down(): void
    {
        Schema::dropIfExists($this->getTableNameWithPrefix());
    }

    public function tableName(): string
    {
        return 'file_uploads';
    }
}
