<?php

namespace Drp\NativeEventApp\GraphQL\Resolvers;

use Drp\NativeEventApp\Models\Contracts\Stylable;
use Illuminate\Support\Collection;

class StylesResolver
{
    public function __invoke(Stylable $stylable): string
    {
        return $stylable->styles()->get(['styles'])
            ->map->styles
            ->reduce(function (Collection $carry, array $value) {
                return $carry->union($value);
            }, collect())
            ->toJson();
    }
}
