<?php

namespace Drp\NativeEventApp\Models\Concerns;

use Drp\NativeEventApp\Database\TableName;
use Illuminate\Support\Str;

trait PrefixedTable
{
    /**
     * @param string $table
     * @return $this
     */
    public function setTable($table): self // phpcs:ignore
    {
        if (Str::startsWith($table, TableName::prefix())) {
            return $this;
        }

        $this->table = TableName::make($table);

        return $this;
    }

    public function getTable(): string
    {
        return TableName::make(parent::getTable());
    }
}
