<?php

namespace Drp\NativeEventApp\Quiz;

use Drp\NativeEventApp\Models\Quiz;
use Drp\NativeEventApp\Quiz\Facades\QuizOperator;

class QuizOperatorProxy
{
    /**
     * @var \Drp\NativeEventApp\Models\Quiz
     */
    private $quiz;

    public function __construct(Quiz $quiz)
    {
        $this->quiz = $quiz;
    }

    public function create(): void
    {
        QuizOperator::create($this->quiz);
    }

    public function start(): void
    {
        QuizOperator::start($this->quiz);
    }

    public function end(): void
    {
        QuizOperator::end($this->quiz);
    }

    public function delete(): void
    {
        QuizOperator::delete($this->quiz);
    }
}
