<?php

namespace Drp\NativeEventApp\Test\Support\Models;

use Drp\NativeEventApp\Auth\HasAuthMethods;
use Drp\NativeEventApp\Contracts\TokenAuthenticatable as TokenAuthenticatableContract;
use Drp\NativeEventApp\Models\Event;
use Drp\NativeEventApp\Models\Model;
use Illuminate\Auth\Authenticatable;
use Illuminate\Contracts\Auth\Authenticatable as AuthenticatableContract;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Support\Collection;
use Laravel\Passport\HasApiTokens;
use Laravel\Passport\Token;

class TokenAuthenticatable extends Model implements AuthenticatableContract, TokenAuthenticatableContract
{
    use Authenticatable, HasAuthMethods, HasApiTokens;

    protected $guarded = [];

    public function tokens(): BelongsTo
    {
        return $this->belongsTo(Token::class, 'id', 'user_id');
    }

    public function token(): ?Token
    {
        return $this->tokens;
    }

    public function getId(): string
    {
        return $this->id;
    }

    public function getMinimumVersion(): int
    {
        return 1;
    }

    public function getEvents(): Collection
    {
        return Event::all();
    }
}
