<?php

namespace Drp\NativeEventApp\Test\Unit;

use Drp\NativeEventApp\EmailAddress;
use Drp\NativeEventApp\Exceptions\InvalidEmailAddress;
use Drp\NativeEventApp\Test\TestCase;

class EmailAddressTest extends TestCase
{
    /** @test */
    public function accepts_a_valid_email_address()
    {
        $this->assertInstanceOf(EmailAddress::class, new EmailAddress('test@example.com'));
    }

    /** @test */
    public function it_throws_an_exception_on_an_invalid_email_address()
    {
        $this->expectException(InvalidEmailAddress::class);

        new EmailAddress('invalid...email@example.com');
    }

    /** @test */
    public function correctly_obfucates()
    {
        $this->assertEquals(
            't**t@example.com',
            (new EmailAddress('test@example.com'))->obfuscated()
        );

        $this->assertEquals(
            'j********h@example.com',
            (new EmailAddress('john.smith@example.com'))->obfuscated()
        );

        $this->assertEquals(
            'm*@example.com',
            (new EmailAddress('me@example.com'))->obfuscated()
        );
    }
}
