<?php

namespace Drp\NativeEventApp\Test\Unit;

use Carbon\Carbon;
use DateInterval;
use Drp\NativeEventApp\Auth\MagicLinkGenerator;
use Drp\NativeEventApp\Test\Support\Fakes\MagicLinkSigner;
use Drp\NativeEventApp\Test\Support\Fakes\QrCode;
use Drp\NativeEventApp\Test\Support\Fakes\Delegate;
use Drp\NativeEventApp\Test\TestCase;

class MagicLinkGeneratorTest extends TestCase
{
    public function setUp(): void
    {
        //
    }

    /**
     * @test
     */
    public function generates_qr_code()
    {
        Carbon::setTestNow('01-01-2019 00:00.00'); //1546301400

        $signer = new MagicLinkSigner;
        $qrCode = new QrCode;
        $generator = new MagicLinkGenerator($signer, $qrCode, 'URL', new DateInterval('PT10M'));
        $delegate = new Delegate;
        $code = $generator->qrCode($delegate);

        $this->assertEquals(
            'QR_IMAGE_500_https://nea.drpg.dev/in?url=URL&id=1&signature=SIGNATURE_1_1546301400&expiry=1546301400',
            $code
        );
    }

    /**
     * @test
     */
    public function generates_signed_url()
    {
        Carbon::setTestNow('01-01-2019 00:00.00'); //1546301400

        $signer = new MagicLinkSigner;
        $qrCode = new QrCode;
        $delegate = new Delegate;
        $generator = new MagicLinkGenerator($signer, $qrCode, 'URL', new DateInterval('PT10M'));
        $url = $generator->url($delegate);

        $this->assertEquals(
            'https://nea.drpg.dev/in?url=URL&id=1&signature=SIGNATURE_1_1546301400&expiry=1546301400',
            $url
        );
    }
}
